Блог пользователя slim-shady

Автор slim-shady, 3 года назад, По-английски

Discussion Thread of CodeNation Innovation Labs Hiring Challenge held on 26 January 2021.

PROBLEM 1 :-

Statement
Sample Test Cases
Extra Test Case

PROBLEM 2 :-

Statement
Sample Test Cases

PROBLEM 3 :-

Statement
Sample Test Cases

PROBLEM 4 :-

Statement
Sample Test Cases

PROBLEM 5 :-

Statement
Sample Test Cases

PROBLEM 6 :-

Statement
Sample Test Cases

PS :- THE CONTEST HAS ENDED. THOSE WHO HAVE PARTICIPATED CAN SHARE THEIR SOLUTIONS. INTERESTED NON — PARTICIPANTS CAN ALSO SHARE THEIR APPROACHES.

  • Проголосовать: нравится
  • +92
  • Проголосовать: не нравится

»
3 года назад, # |
Rev. 4   Проголосовать: нравится +95 Проголосовать: не нравится

Video Editorial with Scoring Distribution: https://youtu.be/8tEXXSc351c

Problem 1:

Observation 1: Notice that the left arrows will form a prefix of any row. L U L can be made L U U without affecting anything. Observation 2: The number of left arrows will decrease as we go from the bottom row to the top row.

These 2 solutions lead to a $$$O(N\cdot M)$$$ DP where N, M are the dimensions of the rectangle.

Problem 2:

Observation 1: If any bit is set in >= 2 numbers in the range, answer is 0. So we can compute prefix frequencies for each bit. Observation 2: Answer will atmost be 2 because we can make the last bit 1 (having two odd integers in the range is sufficient).

So, with the prefix computation, if answer is not 0, it is 2 — (number of odd integers in the range). Solution complexity: $$$O(N + Q)$$$

Problem 3: Simple implementation problem — just store the frequency of every number. Answer = Sum of initial array. Then, ans = min(ans, sum — freq(val) * val) for all values. Solution complexity: $$$O(N)$$$

Problem 4:

We can have a $$$O(N \cdot M)$$$ DP, where DP(i, j) stores the number of ways of spending i days, where at the last day, we did an activity of type j, adhering to all the constraints. Using prefix summations, we can get the transitions in O(1) time.

Problem 5:

Observation 1: The order of the elements does not matter — we can swap any two elements doing the mentioned operations, and also get the xor of any subset of elements.

Observation 2: The above leads to Gaussian elimination based solution — we only care about the basis (linearly independent set) of elements in the array, since we can get all other XORs from it. Thus, the problem is reduced to finding the basis with the smallest sum. We can do this by finding any basis, and reduce the larger basis elements using the smaller ones.

Solution code: http://p.ip.fi/-1b1

Problem 6:

Observation 1: The required node is basically the LCA of all the leaf nodes in the range [L, R]. Observation 2: If we do a DFS order traversal of the tree and store the discovery time of every node, then we only care about finding LCA(first discovered leaf node, last discovered leaf node) in the query range, because all the other nodes lie in between.

Using this, we can solve the problem in $$$O(N \log N)$$$ using various techniques.

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Did the questions have uneven points distribution or the same points for every question?

  • »
    »
    3 года назад, # ^ |
    Rev. 2   Проголосовать: нравится +24 Проголосовать: не нравится

    Problem 6: Segment Tree + LCA

    Video editorial will be very cool. Ashishgup

  • »
    »
    3 года назад, # ^ |
    Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

    Can you elaborate on problem 4?

    Like what will the recurrence relation look like?

    • »
      »
      »
      3 года назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      yes, dp[day][lastact][streak] is very intuitive but how to reduce it to n^2

      • »
        »
        »
        »
        3 года назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        remove streak from dimension, and move it transitions instead. then it can be optimized by prefix sums.

    • »
      »
      »
      3 года назад, # ^ |
        Проголосовать: нравится +4 Проголосовать: не нравится

      $$$dp[i][j] = \sum\limits_{l=1}^{A_j}\sum\limits_{k=1}^{m} dp[i-l][k] - \sum\limits_{l=1}^{A_j}dp[i-l][j]$$$. You can simplify this by defining $$$pre[i][j] = \sum\limits_{l=1}^{i} \sum\limits_{j=1}^{m} dp[i-l][j]$$$

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    In problem 4, we need to define $$$dp[0][j] = \frac{1}{m-1}$$$. So we define $$$dp[0][j] = 1$$$ and divide the final obtained value by $$$(m-1)$$$. Or was there some easy way to define base cases?

    • »
      »
      »
      3 года назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      Suppose we want answer for dp[i][j] and i-A[j]<=0, this is the only case we will be using dp[0][j]. Whenever we encounter this case, we can explicitly add 1 to dp[i][j] instead of defining dp[0][j]=1 and dividing it later. This will solve the issue.

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится +25 Проголосовать: не нравится

    Will the ranklist be revealed?

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится +48 Проголосовать: не нравится

    For problem 6, we can notice that LCA can be thought of as a monoid operation, so we can make a normal segtree on the range [1...N] and store the LCA in the segtree nodes. (we can store -1 corresponding to non-leafs, which will work as an identity element: LCA(x,-1) = x = LCA(-1,x))

    To make it better we can notice that LCA(X,X) = X, so it is also idempotent, so we can use a sparse table as well. Which gives us a fast solution. $$$O((NlogN+Q) * f(N))$$$. Where $$$f(N)$$$ is the time in which you calculate LCA ($$$O(logN)$$$ or $$$O(1)$$$ depending on how you do it)

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    P2: answer can be 1 as well. if in the range, we already have an odd number, then we can add 1 to any even number and their AND will be > 0

  • »
    »
    3 года назад, # ^ |
    Rev. 2   Проголосовать: нравится +1 Проголосовать: не нравится

    Please answer this if you have any suggestions.

    Spoiler
»
3 года назад, # |
  Проголосовать: нравится +13 Проголосовать: не нравится

In problem 6, was Farach Colton LCA the intended solution to find LCA without MLE? or was segment tree solution for LCA sufficient?

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Yes,Lca with segment tree was sufficient.

    • »
      »
      »
      3 года назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      Could you plz explain how to find the lca using segment tree here , I was able to get the observation required but wasn't able to find a way for lca.

      • »
        »
        »
        »
        3 года назад, # ^ |
          Проголосовать: нравится +3 Проголосовать: не нравится

        just use standard min/max segtree, and change min()/max() to lca().

        also, have lca(leaf, non-leaf) = leaf to get lca of leafs only.

        • »
          »
          »
          »
          »
          3 года назад, # ^ |
            Проголосовать: нравится 0 Проголосовать: не нравится

          for computing lca(a, b) use any standard way.

          • »
            »
            »
            »
            »
            »
            3 года назад, # ^ |
            Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

            oh, nice method, I have never done a problem like this before. Also did you solve all the problems XD

          • »
            »
            »
            »
            »
            »
            3 года назад, # ^ |
              Проголосовать: нравится 0 Проголосовать: не нравится

            in the first sample case my ans[-1,3] AC->is [-1,5] but lca(3,5) is 3 then why 5 is considered?

            • »
              »
              »
              »
              »
              »
              »
              3 года назад, # ^ |
                Проголосовать: нравится 0 Проголосовать: не нравится

              Because only the lca of leaf nodes having the label within the given range is asked,you are finding the lca of a internal and a leaf node.

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

can anyone please explain problem statement of problem 1 , i could'nt even understand problem clearly , i tried hard to understand but couldnt ..plz explain anyone..

»
3 года назад, # |
  Проголосовать: нравится +9 Проголосовать: не нравится

This is problem 4 — Problem

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

How do you guys come to know about these contests? Can anyone participate?

»
3 года назад, # |
  Проголосовать: нравится -20 Проголосовать: не нравится

I solved P2, P3 and P6 is there any probability I may get a call?

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится +5 Проголосовать: не нравится

    Depends on how many people gave the test and how many peeps CN are going to interview, which might be revealed in some days.

    • »
      »
      »
      3 года назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      Hey, did you got any response or anything? If yes, please let me know.

      • »
        »
        »
        »
        3 года назад, # ^ |
          Проголосовать: нравится +1 Проголосовать: не нравится

        No i couldn't solve that many problems to expect a response :(, also i am not sure if they will even hire from this test because of all the cheating and since they are hiring through codechef as well.But for a more sure answer you can ask ashishgup.

      • »
        »
        »
        »
        3 года назад, # ^ |
          Проголосовать: нравится +1 Проголосовать: не нравится

        So I was wrong, people who solved at least 4 did got interview calls.

»
3 года назад, # |
  Проголосовать: нравится -46 Проголосовать: не нравится

Will I get the internship interview opportunity ? I solved first 3 Questions. Ashishgup

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

can anyone post the solutions of problem 4?

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Can someone explain 5th question solution in a more detailed way? It will be better if you can mention the required mathematical concepts properly.

»
3 года назад, # |
  Проголосовать: нравится +1 Проголосовать: не нравится

Ashishgup, could you please tell whether the testcases on which the solutions were tested at the time of the contest were only pretests or full testcases.

»
3 года назад, # |
  Проголосовать: нравится +17 Проголосовать: не нравится
  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    So will the answer for fifth problem just be the bitwise OR of all the numbers according to the second solution you explained

    • »
      »
      »
      3 года назад, # ^ |
        Проголосовать: нравится +2 Проголосовать: не нравится

      No it won't be just bitwise OR of all numbers (I actually implemented this during contest and got WA xD) Let's say for some bit B you can have a situation of not having an element whose highest set bit is B , and provided that B is set in some elements.

    • »
      »
      »
      3 года назад, # ^ |
        Проголосовать: нравится +3 Проголосовать: не нравится

      Consider the case 3,6. The answer is 8 but the bitwise OR is 7.

      (In particular, the answer will be equal to bitwise OR if all non-zero bits are linearly independent)

»
22 месяца назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

provide more problems please